/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: XMLUtilTest.java 10:39:55 AM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.util;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;

import junit.framework.TestCase;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * Test of the XMLUtil
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class XMLUtilTest extends TestCase {

    public void testCreateDocumentFromString() {
        String xml = "<test />";
        Document doc = XMLUtil.createDocumentFromString(xml);
        assertEquals(doc.getFirstChild().getNodeName(), "test");
    }

    public void testCreateStringFromDOMDocument()
        throws ParserConfigurationException, TransformerException {
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        DocumentBuilder builder = factory.newDocumentBuilder();
        Document document = builder.newDocument();
        Element element = document.createElement("foo");
        document.appendChild(element);
        String xml = XMLUtil.createStringFromDOMDocument(document);
        String testXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><foo/>";
        assertEquals(xml, testXML);
    }

}
