/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: ShutdownHook.java 1:04:18 PM ddesjardins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.system.terminate;

import org.objectweb.fractal.api.control.IllegalLifeCycleException;
import org.objectweb.fractal.api.control.LifeCycleController;

/**
 * Hook used to stop Petals
 * 
 * @author ddesjardins - eBMWebsourcing
 */
public class ShutdownHook extends Thread {

    private LifeCycleController lifeCycleController;

    public ShutdownHook(LifeCycleController lifeCycleController) {
        super();
        this.lifeCycleController = lifeCycleController;
    }

    public void run() {
        try {
            if (lifeCycleController.getFcState().equals(
                LifeCycleController.STARTED)) {
                lifeCycleController.stopFc();
                System.out.println("Petals is "
                    + lifeCycleController.getFcState());
            }
        } catch (IllegalLifeCycleException e) {
            System.err.println("Problem while stopping Petals");
        }
    }

}
